/*
 * Export a block device providing block regions.
 *
 * Copyright (C) 2018, 2019, 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include "device.h"
#include "region.h"
#include "region_accessor.h"



long Block_device::open_object_resource(fs_object_t *fsobj, int flags,
                                        Resource **resource)
{
  (void) flags;

  fsobj->size = _size;
  PagingAccessor *region = new Block_region_accessor(_paging, _block, _size);

  /* Create and return a new resource object. */

  *resource = new Block_region(region, *fsobj);

  return L4_EOK;
}
